// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class AirlinerCF extends AgileTemplate	{
	String	Flight_num = null;
	String	Model = "B747";
	String	DataURL = null;
	String	sms1 = null, sms2 = null;
	int		code = 6;
	double	dx = 0, dy = 0, dir = 0;
	Airplane	Flight = null;

	// Constructor, which also initializes the Object.
	public AirlinerCF (AC_Info ACI, String flt_num, String datasrc){
		super(ACI);
		Flight_num = flt_num;
		DataURL = datasrc;

		// Write application-logic to build the AC for the AirLiner.
		// Access data sources to get the data, such as, Model, code.
		//
		// For example, "datasource" may be an URL or AirLines-ID.
		// It may send an WebServices request to the private server
		// of the AirLines (e.g United, Delta or Amarican Airlines).
		// The request may retrurn an XML-message containing all
		// the information to build custom Application Component.

		// Application Logic here may get location and other data.

		// Note: This sample Component Factory is using static data,
		// But, in real application, the following code may get data from
		// the databases for the flight "flt_num" from URL "datasource".
		sms1 = "IAD-to-SFO";
		sms2 = "Radio Ch#27";
		dx = 360;	dy = 320;	dir = -120;

		Flight = new Airplane(ACI, Flight_num, Model, code, DataURL);
		Flight.set_location(dx, dy, dir);
		Flight.setSmallMessages(sms1, sms2);
	}

	// This Service Method of the CCG-Object that returns,
	// The Service Method name of the Application Component.
	public String getUpdateLocationMethodName()	{
		return(Flight.getUpdateLocationMethodName());
	}

	// This Service Method of the CCG-Object that returns,
	// The Object name of the Application Component.
	public String getAC_ObjectName()	{
		return(Flight.getAC_ObjectName());
	}

	// Methods to register a Callback.
	public void setCallBackName( String cb_name)	{
		Flight.setCallBackName(cb_name);
	}
	public String getCB_AddMethodName()	{
		return(Flight.getCB_AddMethodName());
	}

    // The Code Generation Method : CGM
    public int CGM (PrintWriter out){

	// Code to integrates the AC with the global Utility Object
	// Method#1:
	/**Flight.setCallBackName("flight_info_table.Display_info");**/
	// The CF may contain code to integrate the AC with global
	// Utility Objects. Also use Publish/Subscribe method to
	// establich communications between the ACs.
	// To accomplish this, CF may use services of the GUI-class

		Flight.CGM(out);

	// Method#2:to integrate the AC with the global Utility Object
	// CF may generate needed code & add it to the AC's code:
		out.println("<script>");
		String tmp = Flight.getCB_AddMethodName();
		out.println(tmp + "(flight_info_table.Display_info)");
		out.println("</script>\n");
	// Please Note: The CCG assuming that the static Global Info table
	// component will be placed in the web-document. Hence,
	// it is using the method: flight_info_table.Display_info

	// This is an example for, how CF could integrate the component
	// with the Predefined Static or  Global components.
		return(0);
    }	// END of the CGM()
}	// END of the Class Definition.