// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class Airplane extends AgileTemplate	{

	String	Flight_num = null, Model = null;
	String	callback_str = null;
	String	Service_func = null;
	String	img_path = null;
	String	sms1 = null, sms2 = null;
	String	data_url = null;
	double	dx = 0, dy = 0, dir = 0;

	final	String	in_coming			= "green";
	final	String	out_going			= "blue";
	final	String	passing_thru		= "grey";
	final	String	high_priority		= "red";

	final	String	neibouring_airport1	= "Light Yellow";
	final	String	neibouring_airport2	= "lavender";
	final	String	air_force			= "Tan";
	final	String	unidentified		= "Rose";

	String	flt_color =  in_coming;
	String	Show_Info_func = null;

String B767 = 	"d=' M 50   0 L 40    -5 L -30   -5 L -50   0 \n" +
			"M 15  -5 L -10  -50 L -15  -50 L  -5 -15 L -5 -5 \n" +
			"M -35 -3 L -45  -20 L -50  -20 L -47  -1 \n" +
			"M -50  0 L -30   -2 L -27    0 \n" +
			"M 10 -15 L 15   -15 L 15   -21 L   6 -21 \n" +
			"		\n" +
			"M 50   0 L 40     5 L -30    5 L -50   0 \n" +
			"M 15   5 L -10   50 L -15   50 L  -5  15 L -5  5 \n" +
			"M -35  3 L -45   20 L -50   20 L -47   1 \n" +
			"M -50  0 L -30    2 L -27    0 \n" +
			"M 10  15 L 15   15 L 15    21 L   6  21'> \n";

String B757=	"d=' M 60 0 L 50 -4 L -45 -4 L -63 0 L -40 -1 L -37 0 \n" +
			"M 15 -4 L -8 -48 L -12 -48 L -5 -20 L -5 -4 \n" +
			"M -47 -4 L -58 -18 L -64 -18 L -58 -1 \n" +
			"M 10 -13 L 15 -13 L 15 -19 L 7 -19 \n" +
			"  \n" +
			"M 60 0 L 50 4 L -45 4 L -63 0 L -40 1 L -37 0 \n" +
			"M 15 4 L -8 48 L -12 48 L -5 20 L -5 4 \n" +
			"M -47 4 L -58 18 L -64 18 L -58 1 \n" +
			"M 10 13 L 15 13 L 15 19 L 7 19 '> \n";

String SF37 =	"d=' M 40 0 L 30 -5 L -30 -5 L -52 0 L -38 -1 L -35 0 \n" +
			"M -35 -4 L -40 -25 L -45 -25 L -48 -1 \n" +
			"M 5 -5 L 0 -57 L -4 -57 L -9 -5 \n" +
			"M 10 -26 L -8 -26 L -8 -30 L 10 -30 L 13 -28 L 10 -26 \n" +
			"M 11 -20 L 11 -36 \n" +
			" \n" +
			"M 40 0 L 30 5 L -30 5 L -52 0 L -38 1 L -35 0 \n" +
			"M -35 4 L -40 25 L -45 25 L -48 1 M 5 5 L 0 57 L -4 57 L -9 5 \n" +
			"M 10 26 L -8 26 L -8 30 L 10 30 L 13 28 L 10 26 \n" +
			"M 11 20 L 11 36 '> \n";

String SF34 =	"d=' M 60 0 L 50 -5 L -30 -5 L -55 0 \n" +
			"M 10 -5 L -10 -52 L -13 -52 L -5 -5 \n" +
			"M -45 -2 L -54 -17 L -58 -17 L -52 0 \n" +
			"M -55 0 L -33 -2 L -30 0 \n" +
			"M -23 -5 L -23 -10 L -37 -10 L -37 -5 L -23 -5 \n" +
			"M -37 -5 L -42 -3 \n" +
			"	\n" +
			"M 60 0 L 50 5 L -30 5 L -55 0 \n" +
			"M 10 5 L -10 52 L -13 52 L -5 5 \n" +
			"M -45 2 L -54 17 L -58 17 L -52 0 \n" +
			"M -55 0 L -33 2 L -30 0 \n" +
			"M -23 5 L -23 10 L -37 10 L -37 5 L -23 5 \n" +
			"M -37 5 L -42 3 '> \n";

String DC10 =	"d=' M 50 0 L 40 -5 L -20 -5 L -45 0 \n" +
			"M 10 -5 L -10 -52 L -13 -52 L -5 -5 \n" +
			"M -35 -2 L -44 -17 L -48 -17 L -42 0 L -23 -2 L -20 0 \n" +
			"M -13 -5 L -13 -10 L -27 -10 L -27 -5 L -13 -5 \n" +
			"M -27 -5 L -32 -3 \n" +
			"	\n" +
			"M 50 0 L 40 5 L -20 5 L -45 0 \n" +
			"M 10 5 L -10 52 L -13 52 L -5 5 \n" +
			"M -35 2 L -44 17 L -48 17 L -42 0 L -23 2 L -20 0 M -13 5 L -13 10 \n" +
			"L -27 10 L -27 5 L -13 5 \n" +
			"M -27 5 L -32 3 '>\n";

String B747 =	"d=' M 60 0 L 50 -5 L 40 -7 L -30 -7 L -65 0 \n" +
			"M 23 -7 L -22 -63 L -27 -63 L -7 -25 L -4 -7 \n" +
			"M -45 -4 L -61 -22 L -65 -22 L -60 -1 \n" +
			"M -65 0 L -40 -2 L -37 0 \n" +
			"M 12 -20 L 18 -20 L 18 -25 L 8 -25 \n" +
			"M -3 -38 L 3 -38 L 3 -43 L -7 -43 \n" +
			"	\n" +
			"M 60  0 L 50   5 L 40   7 L -30  7 L -65 0 \n" +
			"M 23  7 L -22 63 L -27 63 L -7  25 L -4  7 \n" +
			"M -45 4 L -61 22 L -65 22 L -60  1 \n" +
			"M -65 0 L -40  2 L -37   0 \n" +
			"M 12 20 L 18  20 L 18  25 L 8   25 \n" +
			"M -3 38 L 3   38 L 3   43 L -7  43 '> \n";

String A330 =	"d=' M 50 0 L -40 -5 L 35 -6 L -20 -6 L -55 0 L -33 -1 L -30 0 \n" +
			"M 15 -6 L -15 -60 L -20 -60 L -6 -20 L -5 -6 \n" +
			"M -15 -60 L -20 -64 L -22 -64 L -20 -60 \n" +
			"M -41 -3 L -50 -20 L -55 -20 L -50 -1 \n" +
			"M 9 -17 L 15 -17 L 15 -24 L 5 -24 \n" +
			"	\n" +
			"M 50 0 L -40 5 L 35 6 L -20 6 L -55 0 L -33 1 L -30 0 \n" +
			"M 15 6 L -15 60 L -20 60 L -6 20 L -5 6 \n" +
			"M -15 60 L -20 64 L -22 64 L -20 60 \n" +
			"M -41 3 L -50 20 L -55 20 L -50 1 \n" +
			"M 9 17 L 15 17 L 15 24 L 5 24 '> \n";

String A340 =	"d=' M 50 0 L -40 -5 L 35 -6 L -20 -6 L -55 0 L -33 -1 L -30 0 \n" +
			"M 15 -6 L -15 -60 L -20 -60 L -6 -20 L -5 -6 \n" +
			"M -15 -60 L -20 -64 L -22 -64 L -20 -60 \n" +
			"M -41 -3 L -50 -20 L -55 -20 L -50 -1 \n" +
			"M 9 -17 L 15 -17 L 15 -24 L 5 -24 \n" +
			"M -2 -37 L 4 -37 L 4 -44 L 6 -44 \n" +
			"	\n" +
			"M 50 0 L -40 5 L 35 6 L -20 6 L -55 0 L -33 1 L -30 0 \n" +
			"M 15 6 L -15 60 L -20 60 L -6 20 L -5 6 \n" +
			"M -15 60 L -20 64 L -22 64 L -20 60 \n" +
			"M -41 3 L -50 20 L -55 20 L -50 1 \n" +
			"M 9 17 L 15 17 L 15 24 L 5 24 \n" +
			"M -2 37 L 4 37 L 4 44 L 6 44 '> \n";

String MD11 =	"d=' M 50 0 L 40 -4 L 35 -5 L -20 -5 L -38 -3  \n" +
			"M -25 0 L -25 -3 L -41 -3 L -41 0  \n" +
			"M -41 -2 L -44 0 L -32 -1 L -30 0  \n" +
			"M -29 -4 L -38 -15 L -42 -15 L -38 -3  \n" +
			"M 12 -5 L -15 -45 L -19 -45 L -8 -19 L -7 -5  \n" +
			"M 7 -12 L 13 -12 L 13 -18 L 3 -18  \n" +
			"M -15 -45 L -20 -48 L -21 -48 L -19 -45  \n" +
			"	\n" +
			"M 50 0 L 40 4 L 35 5 L -20 5 L -38 3  \n" +
			"M -25 0 L -25 3 L -41 3 L -41 0  \n" +
			"M -41 2 L -44 0 L -32 1 L -30 0  \n" +
			"M -29 4 L -38 15 L -42 15 L -38 3  \n" +
			"M 12 5 L -15 45 L -19 45 L -8 19 L -7 5  \n" +
			"M 7 12 L 13 12 L 13 18 L 3 18  \n" +
			"M -15 45 L -20 48 L -21 48 L -19 45 '>  \n";

String B737 =	"d=' M 50 0 L 40 -4 L 35 -5 L -20 -5 L -38 -3  \n" +
			"M -25 0 L -25 -3 L -41 -3 L -41 0  \n" +
			"M -41 -2 L -44 0 L -32 -1 L -30 0  \n" +
			"M -29 -4 L -38 -15 L -42 -15 L -38 -3  \n" +
			"M 12 -5 L -15 -45 L -19 -45 L -8 -19 L -7 -5  \n" +
			"M 7 -12 L 13 -12 L 13 -18 L 3 -18   \n" +
			"	\n" +
			"M 50 0 L 40 4 L 35 5 L -20 5 L -38 3  \n" +
			"M -25 0 L -25 3 L -41 3 L -41 0  \n" +
			"M -41 2 L -44 0 L -32 1 L -30 0  \n" +
			"M -29 4 L -38 15 L -42 15 L -38 3  \n" +
			"M 12 5 L -15 45 L -19 45 L -8 19 L -7 5  \n" +
			"M 7 12 L 13 12 L 13 18 L 3 18 '>  \n";

	// Constructor, which also initializes the Object.
	public Airplane(AC_Info ACI, String flt_num, String flt_model, int code, String url)	{

		super(ACI);

		Flight_num = flt_num;
		Model = flt_model;
		data_url = url;


		if (code == 1)			flt_color	= out_going;
		else if (code == 2)		flt_color	= passing_thru;
		else if (code == 3)		flt_color	= high_priority;
		else if (code == 4)		flt_color	= neibouring_airport1;
		else if (code == 5)		flt_color	= neibouring_airport2;
		else if (code == 6)		flt_color	= air_force;
		else if (code == 7)		flt_color	= unidentified;

		img_path = B747; // Default Image.
		if (Model.equalsIgnoreCase("B737"))				img_path = B737;
		else if (Model.equalsIgnoreCase("MD11"))		img_path = MD11;
		else if (Model.equalsIgnoreCase("A340"))		img_path = A340;
		else if (Model.equalsIgnoreCase("A330"))		img_path = A330;
		else if (Model.equalsIgnoreCase("DC10"))		img_path = DC10;
		else if (Model.equalsIgnoreCase("SF34"))		img_path = SF34;
		else if (Model.equalsIgnoreCase("SF37"))		img_path = SF37;
		else if (Model.equalsIgnoreCase("B757"))		img_path = B757;
		else if (Model.equalsIgnoreCase("B767"))		img_path = B767;

		if (url == null)	Show_Info_func = "airline_" + UNQ_ID + ".show_info()";
		else				Show_Info_func = "airline_" + UNQ_ID + ".ajax_show_info()";
	}

	public void setSmallMessages(String m1, String m2)
	{
		sms1 = m1;
		sms2 = m2;
	}

	public void set_location(double x, double y, double d)
	{
		dx	= x;
		dy	= y;
		dir	= d;
	}

	// This Service Method of the CCG-Object that returns,
	// The Service Method name of the Application Component.
	public String getUpdateLocationMethodName()	{
		String name = "airline_" + UNQ_ID + ".update_location";
		return(name);
	}
	// This Service Method of the CCG-Object that returns,
	// The Object name of the Application Component.
	public String getAC_ObjectName()	{
		String name = "airline_" + UNQ_ID + "";
		return(name);
	}
	// Alternative method to get the reference to Service Method.
	// The Containr could pass the name of a Variable.
	// The CCG saves the name of the Variable in a Class variable.
	// If Service_func is not null, the CGM makes this INPUT
	// variable point to the Service Method of the Component
	public void setServiceMethodReference( String function_pointer)	{
		Service_func = function_pointer;
	}
	public void setCallBackName( String cb_name)	{
		callback_str = cb_name;
	}
	public String getCB_AddMethodName()	{
		String name = "airline_" + UNQ_ID + ".add_callback";
		return(name);
	}
private int generate_class_def(PrintWriter out) {

		// Code Check, if the CLASS definition is already in the Web document.
		// Include the SECTION-1 (JavaScript class code file for the Application Component)
		if (this.aci.setJScriptClass("airplane_v1_1"))		return(0);
		out.println("<script xlink:href='App1/Airline_class.js' language='text/ecmascript'/>");
		return(0);
}

private int generate_object_init(PrintWriter out) {
out.println("// SECTION-2: Instantiation and Init the Flight Object ");
out.println(" ");
out.println("<script type='text/ecmascript'> ");
String tmp_str = null;
if (data_url == null)
	tmp_str = " '"+Flight_num+"',  null, 'al_id_" + UNQ_ID + "', 'al_img_" + UNQ_ID + "', 'al_loc_" + UNQ_ID + "'";
else
	tmp_str = " '"+Flight_num+"', '" + data_url + "', 'al_id_" + UNQ_ID + "', 'al_img_" + UNQ_ID + "', 'al_loc_" + UNQ_ID + "'";
out.println("var airline_" + UNQ_ID + " = new airline_v1_1(" + tmp_str + " );  ");
out.println("airline_" + UNQ_ID + ".set_location( " + dx + ", " + dy + ", " + dir +" ); ");
out.println(" ");
out.println("// Visual clues for Air Trafic Controler ");
		if ((sms1 != null) && (sms2 != null))	tmp_str = "'sms_" + UNQ_ID + "'";
		else	tmp_str = "null";
out.println("airline_" + UNQ_ID + ".set_clues_ids ('atc_clue1_" + UNQ_ID + "', 'atc_clue2_" + UNQ_ID + "', " + tmp_str + "); ");
out.println(" ");
out.println("// Register a function to call, upon user click on the Airliner-image ");
		if( callback_str != null)
out.println("airline_" + UNQ_ID + ".add_callback( " + callback_str + " ); ");

		if( Service_func != null)
out.println(Service_func + " = airline_" + UNQ_ID + ".update_location");

out.println("</script> ");
out.println(" ");
	return(0);
}

private int generate_svg_code(PrintWriter out) {
out.println("// SECTION-3: SVG Code section to present the Application Component");
out.println("<g id='al_loc_" + UNQ_ID + "' transform='translate(" + dx +", " + dy + ")'>  ");
out.println("	<g id='al_id_" + UNQ_ID + "' transform='scale(0.2)' onmouseover='airline_" + UNQ_ID + ".highlight(1)' onmouseout='airline_" + UNQ_ID + ".highlight(0)' onclick='" + Show_Info_func + "'>  ");
out.println("		<circle id='atc_clue1_" + UNQ_ID + "' cx='0' cy='0' r='50' style='fill:gold;opacity:.25;stroke:black;stroke-width:4;visibility:hidden;'/> ");
out.println("		<path id='al_img_" + UNQ_ID + "' fill='" + flt_color + "' stroke='red' stroke-width='.5pt' transform='rotate( " + dir + ")' ");
out.println("			" + img_path + " ");
out.println("		</path> ");
out.println("		<text font-family='Verdana' x='15' y='0' font-size='24' fill='black'> " + Flight_num + " </text> ");
out.println("		<text font-family='Verdana' x='15' y='25' font-size='24' fill='black'> " + Model + " </text> ");
out.println("		<circle id='atc_clue2_" + UNQ_ID + "' cx='0' cy='0' r='12' style='fill:red;opacity:.75;stroke:black;stroke-width:4;visibility:hidden;'/> ");
		if ((sms1 != null) && (sms2 != null)) {
out.println("		<g id='sms_" + UNQ_ID + "' transform='translate(-50,50)' style='visibility:hidden;' > ");
out.println("			<text d='m1_sms_" + UNQ_ID + "' font-family='Verdana' x='5' y='0' font-size='24' fill='black'> " + sms1 + " </text> ");
out.println("			<text d='m1_sms_" + UNQ_ID + "' font-family='Verdana' x='5' y='25' font-size='24' fill='black'> " + sms2 + " </text> ");
out.println("		</g> ");
		}
out.println(" ");
out.println("	</g> ");
out.println("</g> ");
return(0);
} // End of XML-graphics section

    // The Code Generation Method : CGM
    public int CGM (PrintWriter out) {
			generate_class_def(out);
			generate_object_init(out);
			generate_svg_code (out);
			return 0;
    }	// END of the CGM()

}	// END of the Class Definition.