<%@ page contentType="image/svg-xml" %>
<%@ page import="com.agile.libtemplate.*,java.io.*" buffer="16kb" %>
<svg width='1000' height='700' onload='svg_doc_onload_init(evt)'>
<script type='text/ecmascript'>
<![CDATA[
// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
var SVG_Document = null;

var onload_init_list = new Array();
function svg_doc_onload_init (evt) {

	SVG_Document = evt.getTarget().getOwnerDocument()

	for(var i = 0; i < onload_init_list.length; i++)
		(onload_init_list[i])(evt);
}
]]>
</script>
<%@ include file="info_table.jsp" %>
<script xlink:href='App1/Webservices_class.js' language='text/ecmascript' /> 
<%
	PrintWriter pw=new PrintWriter(out,true);
	AC_Info aci = new AC_Info(request, application);

	Airplane AirLine = new Airplane(aci, "TWA486","B737", 1, "get_info.jsp" );
	AirLine.set_location(70.0, 90.0, 10.0);
	AirLine.setSmallMessages("LAX-to-JFK", "Radio Ch#1116");
	AirLine.setCallBackName("flight_info_table.Display_info");
	AirLine.CGM(pw);
	
	String ac_set_loc_name = AirLine.getUpdateLocationMethodName();
	String ac_object_name = AirLine.getAC_ObjectName();
%>

// Following JScript functions call the Airline-AC's service methods
<script type='text/ecmascript'>
<![CDATA[
var clue1_state = 0;
var clue2_state = 0;
function switch_atc_clue_state (num) {
	if (num == 1) {
		if(clue1_state == 0)	clue1_state = 1;
		else			clue1_state = 0;
		<%=ac_object_name%>.set_visual_clues(1, clue1_state);
	}
	else {
		if(clue2_state == 0)	clue2_state = 1;
		else			clue2_state = 0;
		<%=ac_object_name%>.set_visual_clues(2, clue2_state);
	}
}
var dir_ang = 10.0;
function set_new_lacation(nx, ny, nd, set)
{

	if (set == 1) {
		<%=ac_object_name%>.ajax_update_loc(null);
	}
	else
	if ( nd != 0)	{
		dir_ang += nd;
		<%=ac_set_loc_name%>(0, 0, nd, 0)
	}
	else
	{
		var tdir = dir_ang*22/(7*180)
		var tx = nx*Math.cos(tdir);
		var ty = ny*Math.sin(tdir);
		<%=ac_set_loc_name%>(tx, ty, 0, 0)
	}
}
]]>
</script>
<!-- Display Buttons and control the Airline using the buttons. -->
<g transform='translate(20 500)'>
<g style='visibility:visible;' onclick='set_new_lacation(10, 10, 0, 0)'>
    <rect style='fill:white;stroke:black;' x='0' y='0' width='20' height='20'/>
    <text style='fill:black;font-size:16pt' x='25' y='20'>Move</text>
</g>
<g style='visibility:visible;' onclick='set_new_lacation(0, 0, 10, 0)'>
    <rect style='fill:red;stroke:black;' x='100' y='0' width='20' height='20'/>
    <text style='fill:black;font-size:16pt' x='125' y='20'>Rotate</text>
</g>
<g style='visibility:visible;' onclick='switch_atc_clue_state(1)'>
    <rect style='fill:green;stroke:black;' x='210' y='0' width='20' height='20'/>
    <text style='fill:black;font-size:16pt' x='235' y='20'> Show Clue1</text>
</g>
<g style='visibility:visible;' onclick='switch_atc_clue_state(2)'>
    <rect style='fill:blue;stroke:black;' x='375' y='0' width='20' height='20'/>
    <text style='fill:black;font-size:16pt' x='400' y='20'>Show Clue2</text>
</g>
</g>
</svg> 