<%@ page contentType="image/svg-xml" %>
<%@ page import="com.agile.libtemplate.*,java.io.*" buffer="16kb" %>
<svg width='1000' height='700' onload='svg_doc_onload_init(evt)'>
<script type='text/ecmascript'>
<![CDATA[
// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
var SVG_Document = null;

var onload_init_list = new Array();
function svg_doc_onload_init (evt) {

	SVG_Document = evt.getTarget().getOwnerDocument()

	for(var i = 0; i < onload_init_list.length; i++)
		(onload_init_list[i])(evt);

	setTimeout('move_the_flights()',8000);
}
]]>
</script>

<g id='city_background' style='visibility:hidden;opacity:0.5;'>
<image xlink:href="App1/SFO.GIF" x="10" y="10" width="700" height="500" />
</g>
<g transform='translate(180 520)' onclick='set_background()'>
    <rect style='fill:tan;stroke:black;' x='0' y='0' width='20' height='20'/>
    <text style='fill:black;font-size:14pt' x='25' y='18'> Show/Hide Background</text>
</g>
<script type='text/ecmascript'>
var bg_state = 0;
    function set_background() {
    	if(bg_state == 1)	bg_state = 0;
    	else			bg_state = 1;
	var svgobj = SVG_Document.getElementById('city_background');
	(svgobj.getStyle()).setProperty ('visibility', (bg_state == 1) ? 'visible' : 'hidden');

    }
</script>
// Include a static Global Info Table AC to diplay XML-data
// The Airlene's AC calls function "flight_info_table.Display_info"
<%@ include file="info_table.jsp" %>

//*************************************************************************
//***********   BEGIN: Application Code     *******************************
//*************************************************************************
<script xlink:href='App1/Webservices_class.js' language='text/ecmascript' /> 
<%
	PrintWriter pw=new PrintWriter(out,true);
	AC_Info aci = new AC_Info(request, application);

	Airplane Al1 = new Airplane(aci,"TWA486","B737", 1, "get_info.jsp");
	Al1.setCallBackName("flight_info_table.Display_info");
	Al1.set_location (90, 50, -40);
	Al1.setSmallMessages("LAX-to-JFK", "Radio Ch#36");
	Al1.CGM(pw);
	
	Airplane Al2 = new Airplane(aci,"AA486","SF37", 2, "get_info.jsp");
	Al2.set_location (360, 180, 20);
	Al2.setCallBackName("flight_info_table.Display_info");
	Al2.setSmallMessages("SFO-to-LAX", "Radio Ch#27");
	Al2.CGM(pw);
	
	Airplane Al3 = new Airplane(aci,"UA486","DC10", 4, "get_info.jsp");
	Al3.set_location (400, 400, 45);
	Al3.setCallBackName("flight_info_table.Display_info");
	Al3.setSmallMessages("SFO-to-DFW", "Radio Ch#18");
	Al3.CGM(pw);

	Airplane Al4 = new Airplane(aci,"NW63","A330", 5, "get_info.jsp");
	Al4.set_location (140, 225, 180);
	Al4.setCallBackName("flight_info_table.Display_info");
	Al4.setSmallMessages("LAG-to-SFO", "Radio Ch#45");
	Al4.CGM(pw);

	Airplane Al5 = new Airplane(aci,"SW36","B757", 6, "get_info.jsp");
	Al5.set_location (360, 320, -120);
	Al5.setCallBackName("flight_info_table.Display_info");
	Al5.setSmallMessages("IAD-to-SFO", "Radio Ch#27");	
	Al5.CGM(pw);
	

	Airplane Al6 = new Airplane(aci,"DEL36","B340", 0, "get_info.jsp");
	Al6.set_location (63, 380, -80);
	Al6.setCallBackName("flight_info_table.Display_info");
	Al6.setSmallMessages("DUL-to-SFO", "Radio Ch#43");
	Al6.CGM(pw);
	
	// The following flights do not dispaly any data onclick.
	// I am too lazy to add XML-data to the file.
	Airplane Al7 = new Airplane(aci,"SQ2","B747", 2, null);
	Al7.set_location (63, 30, -80);
	Al7.setCallBackName("flight_info_table.Display_info");
	Al7.setSmallMessages("SIG-to-SFO", "Radio Ch#144");
	Al7.CGM(pw);
	
	Airplane Al8 = new Airplane(aci,"AI99","A340", 7, null);
	Al8.set_location (63, 530, 180);
	Al8.setCallBackName("flight_info_table.Display_info");
	Al8.setSmallMessages("DEL-to-SFO", "Radio Ch#18");
	Al8.CGM(pw);
	
	Airplane Al9 = new Airplane(aci,"AF2","B747", 3, null);
	Al9.set_location (600, 300, 10);
	Al9.setCallBackName("flight_info_table.Display_info");
	Al9.setSmallMessages("SFO-to-IAD", "Radio Ch#18");
	Al9.CGM(pw);
%>
//*************************************************************************
//***********   END  : Application Code     *******************************
//*************************************************************************

<script type="text/javascript">
<![CDATA[
function move_the_flights() {
	// alert("move_the_flights");
	<%=Al1.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al2.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al3.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al4.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al5.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al6.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al7.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al8.getAC_ObjectName()%>.ajax_update_loc(null);
	<%=Al9.getAC_ObjectName()%>.ajax_update_loc(null);
	setTimeout('move_the_flights()',8000);
}
]]>
</script>

</svg> 