<%@ page contentType="image/svg-xml" %>
<%@ page import="com.agile.libtemplate.*,java.io.*" buffer="16kb" %>
<svg width='500' height='450' onload='svg_doc_onload_init(evt)'>
<script type='text/ecmascript'>
<![CDATA[
// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
var onload_init_list = new Array();
function svg_doc_onload_init (evt) {
	for(var i = 0; i < onload_init_list.length; i++)
		(onload_init_list[i])(evt);
}
]]>
</script>

<script type='text/ecmascript'>
var SVG_Document = null;
function init_svg_doc(e) {
	SVG_Document = e.getTarget().getOwnerDocument()
}
onload_init_list[onload_init_list.length] = init_svg_doc;
</script>

// Include a JSP file that contains Objects for subcomponents.
// The names of the CCG-Objects are CCG1, CCG2, CCG3 and CCG4.
<%@ include file="subcomponents.jsp" %>


<%
PrintWriter pwout = new PrintWriter(out, true);

AC_Info aci = new AC_Info(request, application);

// This Atribute may be used to track included CLASS definitions.
request.setAttribute("CLASS_NAMES", "  ");

String	RB_list[] = { CCG1, CCG2, CCG3, CCG4};
	RotateBanner RB = new RotateBanner(aci, RB_list, 4);

	String	RadioB_list[] = { "ORCL", "MSFT", "INTC", "SUNW" };
	RadioButtons RadioB = new RadioButtons (aci, RadioB_list, 4);

//If user cliks on to Rotate the Banners, keeep the Radio buttons insync.
	RB.setCallBackName(RadioB.getButtonSetMethodName());
%>
// A variable to control the second RotateBanner
var temp_serv_func = function() { };
<script type='text/ecmascript'>
function switch_the_banner(grp, num) {
	<% pwout.print(RB.getBannerUpdateMethodName()); %>(num)
	temp_serv_func(num);
}
</script>

<!-- Display Check Boxes and control the Layers using the buttons. -->
<g transform='translate(300 30)'>
<%
	RadioB.setCB_AddMethod("switch_the_banner");
	RadioB.CGM(pwout);
%>
</g>
<%
	RB.CGM(pwout);
%>
<g transform='translate(20 200)'>
<%
String	RB_list2[] = { CCG4, CCG3, CCG2, CCG1}; // Reversed the Order
	RotateBanner RB2 = new RotateBanner(aci, RB_list2, 4);
	RB2.setServiceMethodReference("temp_serv_func");
	RB2.CGM(pwout);
%>
</g>
<%
	// Clear the class list and free the Utility Object
	request.setAttribute("CLASS_NAMES", null);
%>
</svg>