function airline_v1_1(flight_num, flight_url, al_id, img_id, loc_id ) 
{
    this.highlight = highlight;
    this.show_info = show_info;
    this.ajax_show_info = ajax_show_info;
    this.ajax_update_loc = ajax_update_loc;
    this.add_callback = add_callback;
    this.change_color = change_color;
    this.update_location = update_location;
    this.set_location = set_location;
    this.set_clues_ids = set_clues_ids;
    this.set_visual_clues = set_visual_clues;
    this.set_new_sms = set_new_sms;

    var flt_num = flight_num;
    var al_grp = al_id;
    var al_img = img_id;
    var al_loc = loc_id;
    var al_sms = null;
    var callback_func = null;
    var cx = 0, cy = 0, cd = 0;
    var cur_col = 'red';
    var clue1_id = null;
    var clue2_id = null;
    var airliner_url = flight_url + "?FlightNo=" + flight_num;

    function add_callback( cb_name ) { 
   	callback_func = cb_name; 
    }
    function highlight( stat ) { 
	var svgobj = SVG_Document.getElementById(al_grp);

	if (svgobj != null){
		if (stat == 0) {
			svgobj.setAttribute('transform', 'scale(0.2)');
			// change_color( 'blue' )
			if(callback_func != null)	callback_func(null);
			if(al_sms != null) {
    				svgobj = SVG_Document.getElementById(al_sms);
    				(svgobj.getStyle()).setProperty ('visibility', 'hidden');
    			}
		}
		else {
			svgobj.setAttribute('transform', 'scale(0.75)');
			// change_color( 'red' )
			if(al_sms != null) {
	    			svgobj = SVG_Document.getElementById(al_sms);
    				(svgobj.getStyle()).setProperty ('visibility', 'visible' );
    			}
		}
	}
    }
    function get_url_data(data) {
    	if(data.success) {
    		//alert (data.content);
    		if(callback_func != null)	callback_func( data.content );
    	}
	return;
    }
    function ajax_show_info ( ) {
    	if(callback_func != null) {
    	    	// alert ("Alax Get data : " + airliner_url);
    		getURL(airliner_url, get_url_data);
    	}
    }
    function get_loc_data(data) {
	if(data.success) {
	    	// alert (data.content);
		var xml_data = parseXML(data.content);
		var nx = parseInt(xml_data.getElementsByTagName('xloc').item(0).firstChild.data);
		var ny = parseInt(xml_data.getElementsByTagName('yloc').item(0).firstChild.data);
		var dir = parseInt(xml_data.getElementsByTagName('dir').item(0).firstChild.data);
		update_location (nx, ny, dir, 1);
	}
	return;
    }
    function ajax_update_loc (loc_url) {
    	// getURL (loc_url, get_loc_data);
    	var tmp_url = 'get_loc.jsp?cx=' + cx + '&cy=' + cy + '&cd=' + cd + '&end=99';
    	// alert (tmp_url);
	getURL(tmp_url, get_loc_data);
    }
    var switch1 = 1;
    function show_info ( ) {
    	var xml_info = webservices_get_flight_info(airliner_url, flt_num);
    	if(callback_func != null)	callback_func( xml_info );
    	
    	// test_services1( );
    	// test_services2( );
    	// test_services3( );
    }
    
    function test_services1( ) {
        // This function test the AC's service methods.
        // The service functions are global in scope, Hence,
        // may be called from any where in the application.
    	var new_col = 'red';
    	if(cur_col == 'red')	new_col = 'blue';
    	change_color( new_col );
    	update_location(cx+20, cy+20, cd+20, 1);
    }
    var switch1 = 1;
    function test_services2 ( ) { 
        // This function test the AC's service methods.
    	if(switch1 == 1){
	    	set_visual_clues(1, 1);
	    	set_visual_clues(2, 0);
	    	switch1 = 0;
	} else {
	    	set_visual_clues(1, 0);
	    	set_visual_clues(2, 1);
	    	switch1 = 1;
	}
    }
    var switch2 = 1;
    function test_services3 ( ) {  
    	if(switch2 == 1){
	    	set_visual_clues(1, 1);
	    	switch2 = 0;
	} else {
	    	set_visual_clues(1, 0);
	    	switch2 = 1;
	}
    }
    function change_color( new_col ) {
	var svgobj = SVG_Document.getElementById(al_img);
	cur_col = new_col;
	if (svgobj != null)
		(svgobj.getStyle()).setProperty ('fill', cur_col);
    }
    function update_location(nx, ny, dir, set) {

	if(set == 1) // Set the new values.
	{
	    	cx = nx; cy = ny; cd = dir;
	}
	else // Else increment.
	{
		// alert('Increment ' + cx + ' ' + cy + ' ' + cd + ' ');
	    	cx += nx; cy += ny; cd += dir;
	}
	
	var svgobj = SVG_Document.getElementById(al_loc);
	var trans_str = 'translate(' +cx+ ',' +cy+')';
	if (svgobj != null)		svgobj.setAttribute('transform', trans_str);

	var svgobj = SVG_Document.getElementById(al_img);
	var trans_str = 'rotate('+cd+')';
	if (svgobj != null)		svgobj.setAttribute('transform', trans_str);
    }
    function set_location(nx, ny, dir) {
    	cx = nx; cy = ny; cd = dir;
    }
    function set_clues_ids(id1, id2, sms_id) {
    	clue1_id = id1;
    	clue2_id = id2;
    	al_sms = sms_id;
    }
    function set_new_sms(msg1, msg2) {
    	var str = 'm1_' + al_sms;
   	SVG_Document.getElementById(str).firstChild.nodeValue = msg1;
   	str = 'm2_' + al_sms;
   	SVG_Document.getElementById(str).firstChild.nodeValue = msg2;
    }
    function set_visual_clues(clue_code, state) {
    	if((clue_code == 1) && (clue1_id != null)) {
    		var svgobj = SVG_Document.getElementById(clue1_id);
    		(svgobj.getStyle()).setProperty ('visibility', (state == 1) ? 'visible' : 'hidden');
    	}
    	if((clue_code == 2) && (clue2_id != null)) {
	    	var svgobj = SVG_Document.getElementById(clue2_id);
	    	(svgobj.getStyle()).setProperty ('visibility', (state == 1) ? 'visible' : 'hidden');
    	}
    }
}