// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class RB_RB_IntTemp2	{
	public static int RbRbCount = 1;
	RotateBanner2 RB = null;
	RadioButtons2 RadioB = null;
	String UNQ_ID = "rbrb" + RbRbCount++;

	// Constructor, whic also initializes the Object.
	public RB_RB_IntTemp2(AC_Info ACI, Object list[], String names[], int num)
	{
		RB = new RotateBanner2(ACI, list, num);
		RadioB = new RadioButtons2(ACI, names, num);
	}

	// This Service Method of the Integration-Template returns,
	// The Service Method name of the Presentation-block.
	// This returns the method to select a new RadioButtion;
	// which may be called by any component in the web page,
	// this in-turn calls its Callback to switch the banner.
	public String getSwitchBannerName()	{
		return(RadioB.getButtonSetMethodName());
	}

	// The Code Generation Method : CGM
	public int CGM_rb_rb (PrintWriter out) {

		RB.CGM_Rotate (out);
out.println ("<!-- Display Check Boxes and control the Layers using the buttons. --> ");
out.println ("<g transform='translate(300 30)'> ");
		RadioB.CGM_Radio(out);
out.println ("</g> ");

out.println ("<script type='text/ecmascript'> ");
String stb = "switch_the_banner" + UNQ_ID;
out.println ("function " + stb + "(grp, num) { ");
out.print(RB.getBannerUpdateMethodName()); out.println ("(num)");
out.println ("} ");
out.print(RadioB.getCB_AddMethodName()); out.println ("('none', " + stb + ");");

String stb2 = "switched_the_banner" + UNQ_ID;
out.println ("function " + stb2 + "(num) { ");
out.print(RadioB.getButtonSetMethodName()); out.println ("(num)");
out.println ("} ");
out.print(RB.getCB_AddMethodName()); out.println ("(" + stb2 + ");");

out.println ("</script> ");

		return 0;
	}// END of the CGM()


	public int CGM_rb_rb_classes (PrintWriter out) {
		// Call CLASS definitions
		RadioB.CGM_Radio_section1 (out);
		RB.generate_class_def(out);
		return(0);
	}
	public int CGM_rb_rb_inst (PrintWriter out) {
		// Call Object Instantion & Initialization
		RB.generate_class_inst(out);
		RadioB.CGM_Radio_section2 (out);
		return(0);
	}
	public int CGM_rb_rb_svg (PrintWriter out) {
		// Generate SVG code.
		RB.generate_svg_code (out);

		out.println ("<!-- Display Check Boxes and control the Layers using the buttons. --> ");
		out.println ("<g transform='translate(300 30)'> ");

		RadioB.CGM_Radio_section3 (out);
		out.println ("</g> ");
		return(0);
	}
	public int CGM_integration_logic (PrintWriter out) {
		// Generate Integartion code.
		out.println ("<script type='text/ecmascript'> ");
		String stb = "switch_the_banner" + UNQ_ID;
		out.println ("function " + stb + "(grp, num) { ");
		out.print(RB.getBannerUpdateMethodName()); out.println ("(num)");
		out.println ("} ");
		out.print(RadioB.getCB_AddMethodName()); out.println ("('none', " + stb + ");");

		String stb2 = "switched_the_banner" + UNQ_ID;
		out.println ("function " + stb2 + "(num) { ");
		out.print(RadioB.getButtonSetMethodName()); out.println ("(num)");
		out.println ("} ");
		out.print(RB.getCB_AddMethodName()); out.println ("(" + stb2 + ");");

		out.println ("</script> ");
		return(0);
	}

	// The Code Generation Method : CGM
	public int CGM_rb_rb2 (PrintWriter out) {

		// Generate Classes of subcomponents.
		CGM_rb_rb_classes (out);

		// Instantiate the Objects.
		CGM_rb_rb_inst (out);

		// Generate SVG Code.
		CGM_rb_rb_svg(out);

		// Generate Integration Logic.
		CGM_integration_logic(out);
		return 0;
	}// END of the CGM()

}// END of the Class Definition.