<%@ page contentType="image/svg-xml" %>
<%@ page import="com.agile.libtemplate.*,java.io.*" buffer="16kb" %>
<svg width='500' height='200' onload='svg_doc_onload_init(evt)'>
<script type='text/ecmascript'>
<![CDATA[
// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
var onload_init_list = new Array();
function svg_doc_onload_init (evt) {
	for(var i = 0; i < onload_init_list.length; i++)
		(onload_init_list[i])(evt);
}
]]>
</script>

<script type='text/ecmascript'>
var SVG_Document = null;
function init_svg_doc(e) {
	SVG_Document = e.getTarget().getOwnerDocument()
}
onload_init_list[onload_init_list.length] = init_svg_doc;
</script>

// Include a JSP file that contains Objects for subcomponents.
// The names of the CCG-Objects are CCG1, CCG2, CCG3 and CCG4.
<%@ include file="subcomponents.jsp" %>

// Include integration code.
<script type='text/ecmascript'>
// Pick a variable with uinque name for the service method.
var dynamic_service_selection = function() { };
function switch_the_banner(grp, num) { // Impliment a Callback
	dynamic_service_selection(num); // Call the service method
}
</script>

<%
PrintWriter pwout = new PrintWriter(out, true);

String	RB_list[] = { CCG1, CCG2, CCG3, CCG4};
AC_Info aci = new AC_Info(request, application);

	RotateBanner2 RB = new RotateBanner2(aci, RB_list, 4);

	String	RadioB_list[] = { "ORCL", "MSFT", "INTC", "SUNW" };
	RadioButtons2 RadioB = new RadioButtons2 (aci, RadioB_list, 4);

//If user cliks on to Rotate the Banners, keeep the Radio buttons insync.
	RB.setCallBackName(RadioB.getButtonSetMethodName());
%>
<!-- Display Check Boxes and control the Layers using the buttons. -->
<g transform='translate(300 30)'>
<%
	// Register the Callback.
	RadioB.setCB_AddMethod("switch_the_banner");
	RadioB.CGM_Radio(pwout);
%>
</g>
<%
	RB.setBannerUpdateMethodName("dynamic_service_selection");
	RB.CGM_Rotate(pwout); 
%>
</svg>